
#include "ipx/ipx.h"

unsigned long local_net;		// adresa lokalni site (32b)
NODE_ADR local_node;			// adresa lokalniho uzlu (48b)
NODE_ADR gateway;			// adresa brany (48b)
unsigned int netdrv_task;		// cislo tasku ovladace sitove karty
message ipx_msg;			// zprava FS
int first_buf;				// index prvniho neobsazeneho bufferu
int ipx_ready;				// indikace pripravenosti IPX driveru


IPX_PACKET packet;
IPX_BUF buffers[MAX_BUFFERS];
TOS_ELEMENT ipx_tos[MAX_TOS_ELEMENT];


PUBLIC int ipx_init(void) {
	int i;
	first_buf = 0;
	netdrv_task = FS + 1;				// viz. dodelat.txt
	local_net = 0;					// inicializace lokalni site
	ipx_ready = TRUE;				// indikuje cinnost IPX

	// ziskani adresy sitove karty
	ipx_msg.m_source = FS;
	ipx_msg.m_type = C_GETNODE;
	send_recv(netdrv_task, ipx_msg);
	local_node.node_h16 = fs_msg.ntd_gn_lnodeh;
	local_node.node_l32 = fs_msg.ntd_gn_lnodel;

	//inicializace gateway (viz. dodelat.txt)
	gateway.node_h16 = 0;
	gateway.node_l32 = 0;


	for (i = 0; i < MAX_TOS_ELEMENT; i++) {
		ipx_tos[i].wait_proc = 0;
		ipx_tos[i].in_use_flag = FALSE;
	}

	for (i = 0; i < MAX_BUFFERS - 1; i++)
		buffers[i].next = i + 1;
	buffers[i].next = -1;	

	// zaregistrovani IPX u driveru sitove karty
	ipx_msg.m_source = FS;
	ipx_msg.m_type = C_REGISTER;
	ipx_msg.ntd_rg_usertask = FS;
	ipx_msg.ntd_rg_prot = P_IPX;

	send_recv(netdrv_task, ipx_msg);

	// registrace se nezdarila
	if (ipx_msg.ipx_rp_err != OK) {
		ipx_ready = FALSE;
		return ERR;
	}
return OK;
}
