
#include "ipx/ipx.h"
#include "ipx/notify.h"
#include "common/errno.h"

#define EXTERN
#include "fs/inode/read.h"
#include "fs/common/fsmes.h"
#undef EXTERN

// Predpokladame volani send() NE send_recv() !!
PUBLIC int ipx_do_notify(void) {
	int i;
	int packet_len;			// Delka dosleho paketu.
	int tos_index;			// Index soketu kteremu bude paket dorucen.
	int buf_index;			// Index bufferu do ktereho ulozime data paketu.
	int new_buf;			// Adresa datoveho buff. v kruhovem buff. soketu.
	vir_bytes copy_len;		// Pocet bytu ktere se prenesou k uzivateli.
	int result;			// Pocet skutecne zkopirovanych bytu.

// Tato zprava NIC nevraci 
	dont_reply = TRUE;

//1. poslat zpravu READ na sitovou kartu

	ipx_msg.m_source = FS;
	ipx_msg.m_type = C_READ;
	ipx_msg.ntd_rw_usertask = FS;
	ipx_msg.ntd_rw_nbytes = PACKET_LEN;
	ipx_msg.ntd_rw_segment = D;
	ipx_msg.ntd_rw_offset = (char*) &packet;

	send_recv(netdrv_task, ipx_msg);

// Zjistime kolik dat jsme dostali
	packet_len = ipx_msg.ipx_rp_nbytes;
	if (packet_len != packet.length + PACKET_HEAD_LEN) {
		return EIPXSOCK;
	}

//2. vytahnout z packetu cislo portu
//3. pokud neni otevreny, tak se zahodi

	tos_index = -1;
	for (i = 0; i < MAX_TOS_ELEMENT; i++) {
		if (ipx_tos[i].local_port == packet.destination_socket && ipx_tos[i].in_use_flag == TRUE) {
			tos_index = i;
			break;
		}
	}
	if (tos_index < 0) return EIPXSOCK;

//4. jestlize aplikace ceka na data, tak ji je poslu

	if (ipx_tos[tos_index].wait_proc > 0) {

/*PUBLIC int rw_user(int s, int u, char *vir, int bytes, char *buff, int direction)*/
/*Prenos dat mezi adr. prostorem (I/D) uzivatele a FS */
/*int s;			D or T space in user proc */
/*int u;			process # */
/*vir_bytes vir;		address within user space */
/*vir_bytes bytes;		# of bytes to transfer */
/*char *buff;			buffer in FS's space */
/*int direction;		TO_USER /FROM_USER */
/* Call the kernel to read and write user space */

		copy_len = (vir_bytes) min(packet.length, ipx_tos[tos_index].wait_data_len);

		result = rw_user(ipx_tos[tos_index].wait_segment, ipx_tos[tos_index].wait_proc,
			     ipx_tos[tos_index].wait_offset, copy_len, packet.data, TO_USER);

// Test jestli se podarilo data od uzivatele prevzit
		if (result < 0) {
			return EIPXSOCK;
		}
	}

//5. jinak data zkopiruju do bufferu
	else {
		if (first_buf == -1 || ipx_tos[tos_index].buf_len >= MAX_SOCK_BUF)
			return EIPXSOCK;
		buf_index = first_buf;
		first_buf = buffers[buf_index].next;
		for (i = 0; i < packet.length; i++)
			buffers[buf_index].buf[i] = packet.data[i];
		buffers[buf_index].len = i;

		ipx_tos[tos_index].buf_len++;
		new_buf = ipx_tos[tos_index].buf_start + ipx_tos[tos_index].buf_len;
		new_buf %= MAX_SOCK_BUF;
		ipx_tos[tos_index].buffers[new_buf] = buf_index;
	}

return packet.length;
}
	